package ratel.com.soowee.tcyue;

import android.app.Activity;
import android.content.Context;
import android.os.Bundle;
import android.os.Handler;
import android.os.Looper;
import android.util.Log;
import android.view.LayoutInflater;
import android.widget.FrameLayout;

import com.virjar.ratel.api.RatelToolKit;
import com.virjar.ratel.api.extension.socketmonitor.SocketMonitor;
import com.virjar.ratel.api.extension.socketmonitor.observer.FileLogEventObserver;
import com.virjar.ratel.api.extension.superappium.SuperAppium;
import com.virjar.ratel.api.extension.superappium.sekiro.SekiroStarter;
import com.virjar.ratel.api.rposed.IRposedHookLoadPackage;
import com.virjar.ratel.api.rposed.RC_MethodHook;
import com.virjar.ratel.api.rposed.RposedHelpers;
import com.virjar.ratel.api.rposed.callbacks.RC_LoadPackage;
import com.virjar.sekiro.Constants;
import com.virjar.sekiro.log.SekiroLogger;

import java.io.File;

import external.com.alibaba.fastjson.JSON;

/**
 * Created by virjar on 2018/10/6.
 */

public class HookEntry implements IRposedHookLoadPackage {
    private static final String tag = "SW_HOOK";


    @Override
    public void handleLoadPackage(final RC_LoadPackage.LoadPackageParam lpparam) {

        if (lpparam.packageName.equals(lpparam.processName)) {
            SuperAppium.TAG = tag;
            SekiroLogger.tag = tag;
            SekiroStarter.startService("sekiro.virjar.com", Constants.defaultNatServerPort, "virjar-sekiro-test");
            //SekiroClient.start("sekiro.virjar.com", Constants.defaultNatServerPort, UUID.randomUUID().toString(), "sw"
//            )
//                    .registerHandler(new GetUserListAction());
        }

        SocketMonitor.setPacketEventObserver(new FileLogEventObserver(new File(RatelToolKit.whiteSdcardDirPath, "socketMonitor")));

        //com.soowee.tcyue.home.service.HomeService#getUserList
        RposedHelpers.findAndHookMethod("com.soowee.tcyue.home.service.HomeService", lpparam.classLoader,
                "getUserList", "com.soowee.tcyue.home.params.UserlistReqParam",
                "com.soowee.tcyue.common.callback.ReqCallback", new RC_MethodHook() {
                    @Override
                    protected void beforeHookedMethod(MethodHookParam param) throws Throwable {
                        Log.i(tag, "getUserList: " + JSON.toJSONString(param.args[0]));
                    }
                });

        // addFloatingButtonForActivity(lpparam);
        Log.i(tag, "hook end");
    }


    private static void addFloatingButtonForActivity(final RC_LoadPackage.LoadPackageParam lpparam) {
        RposedHelpers.findAndHookMethod(Activity.class, "onCreate", Bundle.class, new RC_MethodHook() {
            @Override
            protected void afterHookedMethod(final MethodHookParam param) throws Throwable {
                new Handler(Looper.getMainLooper())
                        .postDelayed(new Runnable() {
                            @Override
                            public void run() {
                                createAndAttachFloatingButtonOnActivity((Activity) param.thisObject);
                            }
                        }, 1000);
            }

            private void createAndAttachFloatingButtonOnActivity(Activity activity) {
                Context context = RatelToolKit.ratelResourceInterface.createContext(lpparam.modulePath, HookEntry.class.getClassLoader(), RatelToolKit.sContext);

                FrameLayout frameLayout = (FrameLayout) activity.getWindow().getDecorView();
                LayoutInflater.from(context).cloneInContext(context)
                        .inflate(R.layout.float_button, frameLayout);

            }
        });
    }
}
