package ratel.com.soowee.tcyue.sekiro;

import com.virjar.ratel.api.RatelToolKit;
import com.virjar.ratel.api.inspect.ClassLoadMonitor;
import com.virjar.ratel.api.rposed.RposedHelpers;
import com.virjar.sekiro.api.ActionHandler;
import com.virjar.sekiro.api.SekiroRequest;
import com.virjar.sekiro.api.SekiroResponse;
import com.virjar.sekiro.api.databind.AutoBind;

import java.lang.reflect.InvocationHandler;
import java.lang.reflect.Method;
import java.lang.reflect.Proxy;

public class GetUserListAction implements ActionHandler {

    @AutoBind(defaultIntValue = 1)
    private int page = 1;

    @AutoBind(defaultStringValue = "new")
    private String tab = "new";

    @Override
    public void handleRequest(SekiroRequest sekiroRequest, final SekiroResponse sekiroResponse) {


        Object homeService = RposedHelpers.newInstance(
                RposedHelpers.findClassIfExists("com.soowee.tcyue.home.service.HomeService", RatelToolKit.hostClassLoader)
        );

        //com.soowee.tcyue.home.params.UserlistReqParam
        Object userlistReqParam = RposedHelpers.newInstance(
                RposedHelpers.findClassIfExists("com.soowee.tcyue.home.params.UserlistReqParam", RatelToolKit.hostClassLoader)
        );

//05-31 18:35:52.508 22440 22440 I SW_HOOK : getUserList: {"lasttime":0,"page":1,"tab":"new"}
//05-31 18:36:07.202 22440 22440 I SW_HOOK : getUserList: {"lasttime":0,"page":1,"tab":"recomm"}
//05-31 18:36:12.046 22440 22440 I SW_HOOK : getUserList: {"lasttime":0,"page":1,"tab":"newShow"}
//05-31 18:36:13.431 22440 22440 I SW_HOOK : getUserList: {"lasttime":0,"page":1,"tab":"top"}
//05-31 18:36:14.933 22440 22440 I SW_HOOK : getUserList: {"lasttime":0,"page":1,"tab":"hot_user_list"}
//05-31 18:36:17.854 22440 22440 I SW_HOOK : getUserList: {"lasttime":0,"page":1,"tab":"assess_list"}
        RposedHelpers.setObjectField(userlistReqParam, "page", page);
        RposedHelpers.setObjectField(userlistReqParam, "tab", tab);

        //public void getUserList(com.soowee.tcyue.home.params.UserlistReqParam userlistReqParam, final com.soowee.tcyue.common.callback.ReqCallback<com.soowee.tcyue.home.params.UserlistReqParam> callback) {
        Object callback = Proxy.newProxyInstance(RatelToolKit.hostClassLoader, new Class[]{
                ClassLoadMonitor.tryLoadClass("com.soowee.tcyue.common.callback.ReqCallback")
        }, new InvocationHandler() {
            @Override
            public Object invoke(Object proxy, Method method, Object[] args) throws Throwable {
                if (method.getDeclaringClass().equals(ClassLoadMonitor.tryLoadClass("com.soowee.tcyue.common.callback.ReqCallback"))) {

                    /**
                     *   void onFail(int i, java.lang.String str);
                     *
                     *     void onSuccess(T t);
                     */
                    if (method.getName().equals("onSuccess")) {
                        sekiroResponse.success(args[0]);
                    } else if (method.getName().equals("onFail")) {
                        sekiroResponse.failed(String.valueOf(args[1]));
                    }
                    return null;
                }
                return method.invoke(this, args);
            }
        });

        RposedHelpers.callMethod(homeService, "getUserList", userlistReqParam, callback);

    }

    @Override
    public String action() {
        return "getUserList";
    }


}
